t / test-lib.shon commit mergetool: Remove explicit references to /dev/tty (af31471)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset GIT_EDITOR
  47unset AUTHOR_DATE
  48unset AUTHOR_EMAIL
  49unset AUTHOR_NAME
  50unset COMMIT_AUTHOR_EMAIL
  51unset COMMIT_AUTHOR_NAME
  52unset EMAIL
  53unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  54unset GIT_AUTHOR_DATE
  55GIT_AUTHOR_EMAIL=author@example.com
  56GIT_AUTHOR_NAME='A U Thor'
  57unset GIT_COMMITTER_DATE
  58GIT_COMMITTER_EMAIL=committer@example.com
  59GIT_COMMITTER_NAME='C O Mitter'
  60unset GIT_DIFF_OPTS
  61unset GIT_DIR
  62unset GIT_WORK_TREE
  63unset GIT_EXTERNAL_DIFF
  64unset GIT_INDEX_FILE
  65unset GIT_OBJECT_DIRECTORY
  66unset GIT_CEILING_DIRECTORIES
  67unset SHA1_FILE_DIRECTORIES
  68unset SHA1_FILE_DIRECTORY
  69unset GIT_NOTES_REF
  70unset GIT_NOTES_DISPLAY_REF
  71unset GIT_NOTES_REWRITE_REF
  72unset GIT_NOTES_REWRITE_MODE
  73GIT_MERGE_VERBOSITY=5
  74export GIT_MERGE_VERBOSITY
  75export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  76export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  77export EDITOR
  78
  79# Protect ourselves from common misconfiguration to export
  80# CDPATH into the environment
  81unset CDPATH
  82
  83unset GREP_OPTIONS
  84
  85case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  86        1|2|true)
  87                echo "* warning: Some tests will not work if GIT_TRACE" \
  88                        "is set as to trace on STDERR ! *"
  89                echo "* warning: Please set GIT_TRACE to something" \
  90                        "other than 1, 2 or true ! *"
  91                ;;
  92esac
  93
  94# Convenience
  95#
  96# A regexp to match 5 and 40 hexdigits
  97_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  98_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  99
 100# Each test should start with something like this, after copyright notices:
 101#
 102# test_description='Description of this test...
 103# This test checks if command xyzzy does the right thing...
 104# '
 105# . ./test-lib.sh
 106[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 107                TERM=$ORIGINAL_TERM &&
 108                export TERM &&
 109                [ -t 1 ] &&
 110                tput bold >/dev/null 2>&1 &&
 111                tput setaf 1 >/dev/null 2>&1 &&
 112                tput sgr0 >/dev/null 2>&1
 113        ) &&
 114        color=t
 115
 116while test "$#" -ne 0
 117do
 118        case "$1" in
 119        -d|--d|--de|--deb|--debu|--debug)
 120                debug=t; shift ;;
 121        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 122                immediate=t; shift ;;
 123        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 124                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 125        -h|--h|--he|--hel|--help)
 126                help=t; shift ;;
 127        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 128                verbose=t; shift ;;
 129        -q|--q|--qu|--qui|--quie|--quiet)
 130                quiet=t; shift ;;
 131        --with-dashes)
 132                with_dashes=t; shift ;;
 133        --no-color)
 134                color=; shift ;;
 135        --no-python)
 136                # noop now...
 137                shift ;;
 138        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 139                valgrind=t; verbose=t; shift ;;
 140        --tee)
 141                shift ;; # was handled already
 142        --root=*)
 143                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 144                shift ;;
 145        *)
 146                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 147        esac
 148done
 149
 150if test -n "$color"; then
 151        say_color () {
 152                (
 153                TERM=$ORIGINAL_TERM
 154                export TERM
 155                case "$1" in
 156                        error) tput bold; tput setaf 1;; # bold red
 157                        skip)  tput bold; tput setaf 2;; # bold green
 158                        pass)  tput setaf 2;;            # green
 159                        info)  tput setaf 3;;            # brown
 160                        *) test -n "$quiet" && return;;
 161                esac
 162                shift
 163                printf "%s" "$*"
 164                tput sgr0
 165                echo
 166                )
 167        }
 168else
 169        say_color() {
 170                test -z "$1" && test -n "$quiet" && return
 171                shift
 172                echo "$*"
 173        }
 174fi
 175
 176error () {
 177        say_color error "error: $*"
 178        GIT_EXIT_OK=t
 179        exit 1
 180}
 181
 182say () {
 183        say_color info "$*"
 184}
 185
 186test "${test_description}" != "" ||
 187error "Test script did not set test_description."
 188
 189if test "$help" = "t"
 190then
 191        echo "$test_description"
 192        exit 0
 193fi
 194
 195exec 5>&1
 196if test "$verbose" = "t"
 197then
 198        exec 4>&2 3>&1
 199else
 200        exec 4>/dev/null 3>/dev/null
 201fi
 202
 203test_failure=0
 204test_count=0
 205test_fixed=0
 206test_broken=0
 207test_success=0
 208
 209test_external_has_tap=0
 210
 211die () {
 212        code=$?
 213        if test -n "$GIT_EXIT_OK"
 214        then
 215                exit $code
 216        else
 217                echo >&5 "FATAL: Unexpected exit with code $code"
 218                exit 1
 219        fi
 220}
 221
 222GIT_EXIT_OK=
 223trap 'die' EXIT
 224
 225# The semantics of the editor variables are that of invoking
 226# sh -c "$EDITOR \"$@\"" files ...
 227#
 228# If our trash directory contains shell metacharacters, they will be
 229# interpreted if we just set $EDITOR directly, so do a little dance with
 230# environment variables to work around this.
 231#
 232# In particular, quoting isn't enough, as the path may contain the same quote
 233# that we're using.
 234test_set_editor () {
 235        FAKE_EDITOR="$1"
 236        export FAKE_EDITOR
 237        EDITOR='"$FAKE_EDITOR"'
 238        export EDITOR
 239}
 240
 241test_decode_color () {
 242        sed     -e 's/.\[1m/<WHITE>/g' \
 243                -e 's/.\[31m/<RED>/g' \
 244                -e 's/.\[32m/<GREEN>/g' \
 245                -e 's/.\[33m/<YELLOW>/g' \
 246                -e 's/.\[34m/<BLUE>/g' \
 247                -e 's/.\[35m/<MAGENTA>/g' \
 248                -e 's/.\[36m/<CYAN>/g' \
 249                -e 's/.\[m/<RESET>/g'
 250}
 251
 252q_to_nul () {
 253        perl -pe 'y/Q/\000/'
 254}
 255
 256q_to_cr () {
 257        tr Q '\015'
 258}
 259
 260append_cr () {
 261        sed -e 's/$/Q/' | tr Q '\015'
 262}
 263
 264remove_cr () {
 265        tr '\015' Q | sed -e 's/Q$//'
 266}
 267
 268test_tick () {
 269        if test -z "${test_tick+set}"
 270        then
 271                test_tick=1112911993
 272        else
 273                test_tick=$(($test_tick + 60))
 274        fi
 275        GIT_COMMITTER_DATE="$test_tick -0700"
 276        GIT_AUTHOR_DATE="$test_tick -0700"
 277        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 278}
 279
 280# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 281#
 282# This will commit a file with the given contents and the given commit
 283# message.  It will also add a tag with <message> as name.
 284#
 285# Both <file> and <contents> default to <message>.
 286
 287test_commit () {
 288        file=${2:-"$1.t"}
 289        echo "${3-$1}" > "$file" &&
 290        git add "$file" &&
 291        test_tick &&
 292        git commit -m "$1" &&
 293        git tag "$1"
 294}
 295
 296# Call test_merge with the arguments "<message> <commit>", where <commit>
 297# can be a tag pointing to the commit-to-merge.
 298
 299test_merge () {
 300        test_tick &&
 301        git merge -m "$1" "$2" &&
 302        git tag "$1"
 303}
 304
 305# This function helps systems where core.filemode=false is set.
 306# Use it instead of plain 'chmod +x' to set or unset the executable bit
 307# of a file in the working directory and add it to the index.
 308
 309test_chmod () {
 310        chmod "$@" &&
 311        git update-index --add "--chmod=$@"
 312}
 313
 314# Use test_set_prereq to tell that a particular prerequisite is available.
 315# The prerequisite can later be checked for in two ways:
 316#
 317# - Explicitly using test_have_prereq.
 318#
 319# - Implicitly by specifying the prerequisite tag in the calls to
 320#   test_expect_{success,failure,code}.
 321#
 322# The single parameter is the prerequisite tag (a simple word, in all
 323# capital letters by convention).
 324
 325test_set_prereq () {
 326        satisfied="$satisfied$1 "
 327}
 328satisfied=" "
 329
 330test_have_prereq () {
 331        case $satisfied in
 332        *" $1 "*)
 333                : yes, have it ;;
 334        *)
 335                ! : nope ;;
 336        esac
 337}
 338
 339# You are not expected to call test_ok_ and test_failure_ directly, use
 340# the text_expect_* functions instead.
 341
 342test_ok_ () {
 343        test_success=$(($test_success + 1))
 344        say_color "" "ok $test_count - $@"
 345}
 346
 347test_failure_ () {
 348        test_failure=$(($test_failure + 1))
 349        say_color error "not ok - $test_count $1"
 350        shift
 351        echo "$@" | sed -e 's/^/#       /'
 352        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 353}
 354
 355test_known_broken_ok_ () {
 356        test_fixed=$(($test_fixed+1))
 357        say_color "" "ok $test_count - $@ # TODO known breakage"
 358}
 359
 360test_known_broken_failure_ () {
 361        test_broken=$(($test_broken+1))
 362        say_color skip "not ok $test_count - $@ # TODO known breakage"
 363}
 364
 365test_debug () {
 366        test "$debug" = "" || eval "$1"
 367}
 368
 369test_run_ () {
 370        test_cleanup=:
 371        eval >&3 2>&4 "$1"
 372        eval_ret=$?
 373        eval >&3 2>&4 "$test_cleanup"
 374        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 375                echo ""
 376        fi
 377        return 0
 378}
 379
 380test_skip () {
 381        test_count=$(($test_count+1))
 382        to_skip=
 383        for skp in $GIT_SKIP_TESTS
 384        do
 385                case $this_test.$test_count in
 386                $skp)
 387                        to_skip=t
 388                        break
 389                esac
 390        done
 391        if test -z "$to_skip" && test -n "$prereq" &&
 392           ! test_have_prereq "$prereq"
 393        then
 394                to_skip=t
 395        fi
 396        case "$to_skip" in
 397        t)
 398                say_color skip >&3 "skipping test: $@"
 399                say_color skip "ok $test_count # skip $1"
 400                : true
 401                ;;
 402        *)
 403                false
 404                ;;
 405        esac
 406}
 407
 408test_expect_failure () {
 409        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 410        test "$#" = 2 ||
 411        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 412        if ! test_skip "$@"
 413        then
 414                say >&3 "checking known breakage: $2"
 415                test_run_ "$2"
 416                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 417                then
 418                        test_known_broken_ok_ "$1"
 419                else
 420                        test_known_broken_failure_ "$1"
 421                fi
 422        fi
 423        echo >&3 ""
 424}
 425
 426test_expect_success () {
 427        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 428        test "$#" = 2 ||
 429        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 430        if ! test_skip "$@"
 431        then
 432                say >&3 "expecting success: $2"
 433                test_run_ "$2"
 434                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 435                then
 436                        test_ok_ "$1"
 437                else
 438                        test_failure_ "$@"
 439                fi
 440        fi
 441        echo >&3 ""
 442}
 443
 444test_expect_code () {
 445        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 446        test "$#" = 3 ||
 447        error "bug in the test script: not 3 or 4 parameters to test-expect-code"
 448        if ! test_skip "$@"
 449        then
 450                say >&3 "expecting exit code $1: $3"
 451                test_run_ "$3"
 452                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 453                then
 454                        test_ok_ "$2"
 455                else
 456                        test_failure_ "$@"
 457                fi
 458        fi
 459        echo >&3 ""
 460}
 461
 462# test_external runs external test scripts that provide continuous
 463# test output about their progress, and succeeds/fails on
 464# zero/non-zero exit code.  It outputs the test output on stdout even
 465# in non-verbose mode, and announces the external script with "# run
 466# <n>: ..." before running it.  When providing relative paths, keep in
 467# mind that all scripts run in "trash directory".
 468# Usage: test_external description command arguments...
 469# Example: test_external 'Perl API' perl ../path/to/test.pl
 470test_external () {
 471        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 472        test "$#" = 3 ||
 473        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 474        descr="$1"
 475        shift
 476        if ! test_skip "$descr" "$@"
 477        then
 478                # Announce the script to reduce confusion about the
 479                # test output that follows.
 480                say_color "" "# run $test_count: $descr ($*)"
 481                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 482                # to be able to use them in script
 483                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 484                # Run command; redirect its stderr to &4 as in
 485                # test_run_, but keep its stdout on our stdout even in
 486                # non-verbose mode.
 487                "$@" 2>&4
 488                if [ "$?" = 0 ]
 489                then
 490                        if test $test_external_has_tap -eq 0; then
 491                                test_ok_ "$descr"
 492                        else
 493                                say_color "" "# test_external test $descr was ok"
 494                                test_success=$(($test_success + 1))
 495                        fi
 496                else
 497                        if test $test_external_has_tap -eq 0; then
 498                                test_failure_ "$descr" "$@"
 499                        else
 500                                say_color error "# test_external test $descr failed: $@"
 501                                test_failure=$(($test_failure + 1))
 502                        fi
 503                fi
 504        fi
 505}
 506
 507# Like test_external, but in addition tests that the command generated
 508# no output on stderr.
 509test_external_without_stderr () {
 510        # The temporary file has no (and must have no) security
 511        # implications.
 512        tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
 513        stderr="$tmp/git-external-stderr.$$.tmp"
 514        test_external "$@" 4> "$stderr"
 515        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 516        descr="no stderr: $1"
 517        shift
 518        say >&3 "# expecting no stderr from previous command"
 519        if [ ! -s "$stderr" ]; then
 520                rm "$stderr"
 521
 522                if test $test_external_has_tap -eq 0; then
 523                        test_ok_ "$descr"
 524                else
 525                        say_color "" "# test_external_without_stderr test $descr was ok"
 526                        test_success=$(($test_success + 1))
 527                fi
 528        else
 529                if [ "$verbose" = t ]; then
 530                        output=`echo; echo "# Stderr is:"; cat "$stderr"`
 531                else
 532                        output=
 533                fi
 534                # rm first in case test_failure exits.
 535                rm "$stderr"
 536                if test $test_external_has_tap -eq 0; then
 537                        test_failure_ "$descr" "$@" "$output"
 538                else
 539                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 540                        test_failure=$(($test_failure + 1))
 541                fi
 542        fi
 543}
 544
 545# This is not among top-level (test_expect_success | test_expect_failure)
 546# but is a prefix that can be used in the test script, like:
 547#
 548#       test_expect_success 'complain and die' '
 549#           do something &&
 550#           do something else &&
 551#           test_must_fail git checkout ../outerspace
 552#       '
 553#
 554# Writing this as "! git checkout ../outerspace" is wrong, because
 555# the failure could be due to a segv.  We want a controlled failure.
 556
 557test_must_fail () {
 558        "$@"
 559        test $? -gt 0 -a $? -le 129 -o $? -gt 192
 560}
 561
 562# Similar to test_must_fail, but tolerates success, too.  This is
 563# meant to be used in contexts like:
 564#
 565#       test_expect_success 'some command works without configuration' '
 566#               test_might_fail git config --unset all.configuration &&
 567#               do something
 568#       '
 569#
 570# Writing "git config --unset all.configuration || :" would be wrong,
 571# because we want to notice if it fails due to segv.
 572
 573test_might_fail () {
 574        "$@"
 575        test $? -ge 0 -a $? -le 129 -o $? -gt 192
 576}
 577
 578# test_cmp is a helper function to compare actual and expected output.
 579# You can use it like:
 580#
 581#       test_expect_success 'foo works' '
 582#               echo expected >expected &&
 583#               foo >actual &&
 584#               test_cmp expected actual
 585#       '
 586#
 587# This could be written as either "cmp" or "diff -u", but:
 588# - cmp's output is not nearly as easy to read as diff -u
 589# - not all diff versions understand "-u"
 590
 591test_cmp() {
 592        $GIT_TEST_CMP "$@"
 593}
 594
 595# This function can be used to schedule some commands to be run
 596# unconditionally at the end of the test to restore sanity:
 597#
 598#       test_expect_success 'test core.capslock' '
 599#               git config core.capslock true &&
 600#               test_when_finished "git config --unset core.capslock" &&
 601#               hello world
 602#       '
 603#
 604# That would be roughly equivalent to
 605#
 606#       test_expect_success 'test core.capslock' '
 607#               git config core.capslock true &&
 608#               hello world
 609#               git config --unset core.capslock
 610#       '
 611#
 612# except that the greeting and config --unset must both succeed for
 613# the test to pass.
 614
 615test_when_finished () {
 616        test_cleanup="{ $*
 617                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 618}
 619
 620# Most tests can use the created repository, but some may need to create more.
 621# Usage: test_create_repo <directory>
 622test_create_repo () {
 623        test "$#" = 1 ||
 624        error "bug in the test script: not 1 parameter to test-create-repo"
 625        owd=`pwd`
 626        repo="$1"
 627        mkdir -p "$repo"
 628        cd "$repo" || error "Cannot setup test environment"
 629        "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
 630        error "cannot run git init -- have you built things yet?"
 631        mv .git/hooks .git/hooks-disabled
 632        cd "$owd"
 633}
 634
 635test_done () {
 636        GIT_EXIT_OK=t
 637        test_results_dir="$TEST_DIRECTORY/test-results"
 638        mkdir -p "$test_results_dir"
 639        test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 640
 641        echo "total $test_count" >> $test_results_path
 642        echo "success $test_success" >> $test_results_path
 643        echo "fixed $test_fixed" >> $test_results_path
 644        echo "broken $test_broken" >> $test_results_path
 645        echo "failed $test_failure" >> $test_results_path
 646        echo "" >> $test_results_path
 647
 648        if test "$test_fixed" != 0
 649        then
 650                say_color pass "# fixed $test_fixed known breakage(s)"
 651        fi
 652        if test "$test_broken" != 0
 653        then
 654                say_color error "# still have $test_broken known breakage(s)"
 655                msg="remaining $(($test_count-$test_broken)) test(s)"
 656        else
 657                msg="$test_count test(s)"
 658        fi
 659        case "$test_failure" in
 660        0)
 661                # Maybe print SKIP message
 662                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 663
 664                if test $test_external_has_tap -eq 0; then
 665                        say_color pass "# passed all $msg"
 666                        say "1..$test_count$skip_all"
 667                fi
 668
 669                test -d "$remove_trash" &&
 670                cd "$(dirname "$remove_trash")" &&
 671                rm -rf "$(basename "$remove_trash")"
 672
 673                exit 0 ;;
 674
 675        *)
 676                if test $test_external_has_tap -eq 0; then
 677                        say_color error "# failed $test_failure among $msg"
 678                        say "1..$test_count"
 679                fi
 680
 681                exit 1 ;;
 682
 683        esac
 684}
 685
 686# Test the binaries we have just built.  The tests are kept in
 687# t/ subdirectory and are run in 'trash directory' subdirectory.
 688TEST_DIRECTORY=$(pwd)
 689if test -n "$valgrind"
 690then
 691        make_symlink () {
 692                test -h "$2" &&
 693                test "$1" = "$(readlink "$2")" || {
 694                        # be super paranoid
 695                        if mkdir "$2".lock
 696                        then
 697                                rm -f "$2" &&
 698                                ln -s "$1" "$2" &&
 699                                rm -r "$2".lock
 700                        else
 701                                while test -d "$2".lock
 702                                do
 703                                        say "Waiting for lock on $2."
 704                                        sleep 1
 705                                done
 706                        fi
 707                }
 708        }
 709
 710        make_valgrind_symlink () {
 711                # handle only executables
 712                test -x "$1" || return
 713
 714                base=$(basename "$1")
 715                symlink_target=$TEST_DIRECTORY/../$base
 716                # do not override scripts
 717                if test -x "$symlink_target" &&
 718                    test ! -d "$symlink_target" &&
 719                    test "#!" != "$(head -c 2 < "$symlink_target")"
 720                then
 721                        symlink_target=../valgrind.sh
 722                fi
 723                case "$base" in
 724                *.sh|*.perl)
 725                        symlink_target=../unprocessed-script
 726                esac
 727                # create the link, or replace it if it is out of date
 728                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 729        }
 730
 731        # override all git executables in TEST_DIRECTORY/..
 732        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 733        mkdir -p "$GIT_VALGRIND"/bin
 734        for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
 735        do
 736                make_valgrind_symlink $file
 737        done
 738        OLDIFS=$IFS
 739        IFS=:
 740        for path in $PATH
 741        do
 742                ls "$path"/git-* 2> /dev/null |
 743                while read file
 744                do
 745                        make_valgrind_symlink "$file"
 746                done
 747        done
 748        IFS=$OLDIFS
 749        PATH=$GIT_VALGRIND/bin:$PATH
 750        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 751        export GIT_VALGRIND
 752elif test -n "$GIT_TEST_INSTALLED" ; then
 753        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 754        error "Cannot run git from $GIT_TEST_INSTALLED."
 755        PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
 756        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 757else # normal case, use ../bin-wrappers only unless $with_dashes:
 758        git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
 759        if ! test -x "$git_bin_dir/git" ; then
 760                if test -z "$with_dashes" ; then
 761                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 762                fi
 763                with_dashes=t
 764        fi
 765        PATH="$git_bin_dir:$PATH"
 766        GIT_EXEC_PATH=$TEST_DIRECTORY/..
 767        if test -n "$with_dashes" ; then
 768                PATH="$TEST_DIRECTORY/..:$PATH"
 769        fi
 770fi
 771GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
 772unset GIT_CONFIG
 773GIT_CONFIG_NOSYSTEM=1
 774GIT_CONFIG_NOGLOBAL=1
 775export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
 776
 777. ../GIT-BUILD-OPTIONS
 778
 779if test -z "$GIT_TEST_CMP"
 780then
 781        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 782        then
 783                GIT_TEST_CMP="$DIFF -c"
 784        else
 785                GIT_TEST_CMP="$DIFF -u"
 786        fi
 787fi
 788
 789GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
 790export GITPERLLIB
 791test -d ../templates/blt || {
 792        error "You haven't built things yet, have you?"
 793}
 794
 795if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 796then
 797        GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
 798        export GITPYTHONLIB
 799        test -d ../git_remote_helpers/build || {
 800                error "You haven't built git_remote_helpers yet, have you?"
 801        }
 802fi
 803
 804if ! test -x ../test-chmtime; then
 805        echo >&2 'You need to build test-chmtime:'
 806        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 807        exit 1
 808fi
 809
 810# Test repository
 811test="trash directory.$(basename "$0" .sh)"
 812test -n "$root" && test="$root/$test"
 813case "$test" in
 814/*) TRASH_DIRECTORY="$test" ;;
 815 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
 816esac
 817test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 818rm -fr "$test" || {
 819        GIT_EXIT_OK=t
 820        echo >&5 "FATAL: Cannot prepare test area"
 821        exit 1
 822}
 823
 824test_create_repo "$test"
 825# Use -P to resolve symlinks in our working directory so that the cwd
 826# in subprocesses like git equals our $PWD (for pathname comparisons).
 827cd -P "$test" || exit 1
 828
 829this_test=${0##*/}
 830this_test=${this_test%%-*}
 831for skp in $GIT_SKIP_TESTS
 832do
 833        case "$this_test" in
 834        $skp)
 835                say_color skip >&3 "skipping test $this_test altogether"
 836                skip_all="skip all tests in $this_test"
 837                test_done
 838        esac
 839done
 840
 841# Provide an implementation of the 'yes' utility
 842yes () {
 843        if test $# = 0
 844        then
 845                y=y
 846        else
 847                y="$*"
 848        fi
 849
 850        while echo "$y"
 851        do
 852                :
 853        done
 854}
 855
 856# Fix some commands on Windows
 857case $(uname -s) in
 858*MINGW*)
 859        # Windows has its own (incompatible) sort and find
 860        sort () {
 861                /usr/bin/sort "$@"
 862        }
 863        find () {
 864                /usr/bin/find "$@"
 865        }
 866        sum () {
 867                md5sum "$@"
 868        }
 869        # git sees Windows-style pwd
 870        pwd () {
 871                builtin pwd -W
 872        }
 873        # no POSIX permissions
 874        # backslashes in pathspec are converted to '/'
 875        # exec does not inherit the PID
 876        ;;
 877*)
 878        test_set_prereq POSIXPERM
 879        test_set_prereq BSLASHPSPEC
 880        test_set_prereq EXECKEEPSPID
 881        ;;
 882esac
 883
 884test -z "$NO_PERL" && test_set_prereq PERL
 885test -z "$NO_PYTHON" && test_set_prereq PYTHON
 886
 887# test whether the filesystem supports symbolic links
 888ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
 889rm -f y